<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>

<body>
    <!--
   Напишите функцию конструктор BankCard, которая будет создавать объекты, описывающие банковские карты. У функции - конструктора должны быть такие аргументы:
   - cardholderName;
   - type (MastedCard by default);
   - date;
   - pin;
   - bankName;
   - deposit

    При создании экземпляра карты должен создаваться обьект банковской карты с публичными свойствами
    - cardholderName
    - type
    - date
    - bankName
    - cardNumber - строка, состоящая из 16 чисел карты, из которых видимые - только 4 - пример ("**** **** **** 1234");

    Внутри у экземпляра - должны автоматом генерироваться "номер карты" и "cvv" код - которые будут присвоены экземпляру
     (но будут скрытые)
    Пин код должен также быть скрыт, без получения на чтения (только перезапись)
    Также у карты должны быть методы -

    - получить деньги (pin, cashAmount) - проверяет пин код и если все ок - возвращает сумму (вычитает в deposit); - если
    нет - генерирует ошибку
    - перевести деньги (cvv, amount, cardToTransfer) - проверяет данные, снимает сумму и возвращает инвойс:
    `
        Перевод:    /текущая дата/
        С карты:     /номер карты текущей/
        На карту:     /номер куда переводили (последние 4 только видимые)/
        Сумма:       /указанная сумма/
        Статус:      /успех, отказ/
        Банк:   /имя банка/
    `
    - сменить пин код (current, new)
    - пополнить депозит (pin, newAmount)
    - заблокировать карту (cardName, cvv) `Ваша карта заблокирована, обратитесь в /имя банка/`

    В случае если пин код - был введен 3 раза неправильно - все методы должны блокироваться с уведомлением `Вы исчерпали
    количество допустимых вводом пин кода. Ваша карта заблокирована, обратитесь в /имя банка/`

    Все методы должны валидироваться и в случае ошибки (любой на ваш взгляд - должны выдавать Error) -->
    <script>
        function  BankCard({cardholderName, type = 'MastedCard', date, bankName, pin, deposit}) {
            let cardPin = pin;
            let cardNumber = generateRandom(16);
            let cvv = generateRandom(3);

            let incorrectPin = 0;

            this.cardholderName = cardholderName;
            this.type = type;
            this.date = date;
            this.bankName = bankName;

            this.getCardNumber = () => {
                return `**** **** **** ${cardNumber%(10**4)}`
            };

            this.getCash = (pin, cashAmount) => {
                checkPin.call(this, pin);

                if (typeof cashAmount !== 'number' || cashAmount < 0) {
                    throw new Error('Cash amount incorrect!');
                }

                if (deposit - cashAmount <= 0) {
                    throw new Error('Not enough money');
                }

                deposit -= cashAmount;
                return cashAmount;
            };

            function checkPin(pin) {
                if (incorrectPin === 3) {
                    throw new Error(`Вы исчерпали количество допустимых вводом пин кода. Ваша карта заблокирована, обратитесь в ${this.bankName}`);
                }

                if (pin !== cardPin) {
                    incorrectPin++;
                    throw new Error('Incorrect pin');
                }
            }

            function generateRandom(pow) {
                return Math.round(Math.random()* (10**pow));
            }

        }

        const card = new BankCard({cardholderName: 'Ivanov', date: Date.now(), bankName: 'Privat', pin: 1475, deposit: 10000});

        console.log(card);
        //console.log(card.getCash(1476, 100));

    </script>

</body>

</html>
